CBW_Battle.Action.CharmBeam=function(mo,doaction)
	if not(CBW_Battle.CanDoAction(mo.player)) then return end
	
	//Action Info
	mo.player.actiontext = "Charm Beam"
	mo.player.actionrings = 10
	mo.player.action2text = nil
	doaction = CBW_Battle.CheckRings(mo.player,$)
	//Launch Beam
	if doaction == 1 then
		local charm = P_SPMAngle(mo,MT_CHARM,mo.angle,0)
		if charm and charm.valid then
			S_StartSound(charm,sfx_s3kb8)
			charm.scale = $/2
			charm.destscale = $*4
			charm.scalespeed = $/2
			if G_GametypeHasTeams() then
				charm.color = mo.color
			end
			CBW_Battle.PayRings(mo.player)
			mo.player.actioncooldown = TICRATE
		end
	end
end

CBW_Battle.DoCharmed=function(player,charmtime)
	local skin = skins[player.mo.skin]
	//Register debuff and remove powerups
	if charmtime != nil then
		S_StartSound(pmo,sfx_kc59)
		player.charmedtime = TICRATE*6
		player.actioncooldown = player.charmedtime
		player.charmed = true
		P_SwitchShield(player,0)
		player.powers[pw_sneakers] = min($,2)
	end
	//Apply debuff
	if player.charmedtime and player.charmed then
		if player.pflags&PF_JUMPED then
			player.pflags = $|PF_THOKKED
		end
		player.charability = 0
		player.normalspeed = skin.normalspeed*3/4
		player.thrustfactor = skin.thrustfactor-1
		//Do aesthetic
		if not(player.charmedtime&6)
			player.mo.color = SKINCOLOR_CARBON
		else
			player.mo.color = player.skincolor
		end
	end
	//Unregister debuff and apply normal stats
	if not(player.charmedtime) and player.charmed then
		player.charmed = false
		S_StartSound(player.mo,sfx_kc5a)
		player.charability = skin.ability
		player.normalspeed = skin.normalspeed
		player.thrustfactor = skin.thrustfactor
		player.mo.color = player.skincolor
	end
end

CBW_Battle.CharmBeamThinker=function(mo)
	local ghost = P_SpawnGhostMobj(mo)
	local newscale = FRACUNIT / 2
	ghost.scale = FixedMul($,newscale)
	ghost.z = $+ghost.height/2
	if P_RandomChance(FRACUNIT/8)
		P_SpawnMobj(mo.x+P_RandomRange(-mo.radius/FRACUNIT,mo.radius/FRACUNIT)*FRACUNIT,mo.y+P_RandomRange(-mo.radius/FRACUNIT,mo.radius/FRACUNIT)*FRACUNIT,mo.z+P_RandomRange(0,mo.height/FRACUNIT)*FRACUNIT,MT_SPARK)
	end
end

CBW_Battle.CharmBeamCollision=function(pmo,mo,source)
	if not(mo and mo.valid and mo.type == MT_CHARM) then return end
	if not(pmo and pmo.valid and pmo.player) then return end
	if not(source and source.valid and source.player) then return end
	//Player cannot interact
	if not(CBW_Battle.PlayerCanBeDamaged(pmo.player) or CBW_Battle.MyTeam(pmo.player,source.player)) then return end
	//Same team
	if source.player and CBW_Battle.MyTeam(source.player,pmo.player) then
		mo.target = pmo
		A_GiveShield(mo,SH_FORCE|1)
		S_StartSound(pmo,sfx_forcsg)
		pmo.player.rings = $+10
		S_StartSound(pmo,sfx_itemup)
		P_AddPlayerScore(source.player,25)
		return false
	end
	//Enemy
	S_StartSound(pmo,sfx_cdpcm6)
	P_DoPlayerPain(pmo.player,mo,source)
	P_PlayerFlagBurst(pmo.player,false)
	CBW_Battle.DoCharmed(pmo.player,TICRATE*8)
	if multiplayer and not(splitscreen) then print(CBW_Battle.CustomHurtMessage(pmo.player,source,"charm beam","disabled")) end
	if not(CBW_Battle.TagNakedHit(pmo,mo,source,false))
		if G_TagGametype() then //CBW_Battle.TagNakedHit only rewards points if function returns true. To compensate...
			P_AddPlayerScore(source.player,100)
		else
			P_AddPlayerScore(source.player,50)
		end
	end
	return true //Player can never actually be damaged or killed by this projectile
end

CBW_Battle.PlayerHeartCollision = function(mo,heart,owner)
	//Relegate this hook to interactions with players and heart projectiles
	if not(mo and mo.valid) then return end
	if not(mo.player) then return end
	if not(heart and heart.valid and heart.type == MT_LHRT) then return end
	if not(owner and owner.type == MT_PLAYER) then return end
	//Player vs tagged
	if mo.player.pflags&PF_TAGIT and not(owner.player.pflags&PF_TAGIT) then return false end
	//Players
	if CBW_Battle.PlayerCanBeDamaged(mo.player) and not(CBW_Battle.MyTeam(owner.player,mo.player))
		then
		if G_TagGametype()
			if not(CBW_Battle.TagNakedHit(mo,heart,owner,true)) then P_AddPlayerScore(owner.player,50) end
			return true
		elseif mo.player.battle_def
			P_InstaThrust(mo,R_PointToAngle2(0,0,heart.momx,heart.momy),heart.scale*10)
			S_StartSound(mo,sfx_s3k7b)
			return false
		else
			return true
		end
	end
	if //Shield and reward points
		not(mo.player.powers[pw_shield]) and not(mo.player.charability2 == CA2_MELEE)
		and CBW_Battle.MyTeam(mo.player,owner.player)
		then
		P_AddPlayerScore(owner.player,25)
		P_SwitchShield(mo.player,4)
		S_StartSound(mo,sfx_shield)
		return 
	end
	return nil
end