local B = CBW_Battle

B.ERCThink=function(mo)
	if mo.target and mo.target.valid and mo.target.player and mo.target.player.actionstate != 0 then
		local dist = FRACUNIT*68
		local angle = -ANGLE_22h
		if mo.target.player.storeangle != nil then angle = $+mo.target.player.storeangle
		else angle = $+mo.target.angle
		end
		local x = mo.target.x+P_ReturnThrustX(nil,angle,dist)
		local y = mo.target.y+P_ReturnThrustY(nil,angle,dist)
		local z = mo.target.z+mo.target.scale*38
		P_TeleportMove(mo,x,y,z)
	else
		P_RemoveMobj(mo)
	end
end

B.ERLShift=function(mo)
	if mo.target and mo.target.valid and mo.target.player and mo.target.player.actionstate != 0 then
		local dist = FRACUNIT*76
		local angle = -ANGLE_22h
		if mo.target.player.storeangle != nil then angle = $+mo.target.player.storeangle
		else angle = $+mo.target.angle
		end
		local x = mo.target.x+P_ReturnThrustX(nil,angle,dist)
		local y = mo.target.y+P_ReturnThrustY(nil,angle,dist)
		local z = mo.target.z+mo.target.scale*48
		P_TeleportMove(mo,x,y,z)
	else
		P_RemoveMobj(mo)
	end
end

B.Action.TagEggRobo=function(mo,doaction,throwring,tossflag)
	//Player object control
	mo.player.pflags = $|PF_THOKKED
	mo.player.charflags = $&~SF_DASHMODE
	mo.player.charability = CA_NONE
	mo.player.charability2 = CA2_NONE
	if mo.skin != "sonic" and mo.skin != "tails" and mo.skin != "knuckles" and mo.skin != "amy" and mo.skin != "fang" and mo.skin != "metalsonic" then
		R_SetPlayerSkin(mo.player,"sonic")
	end
	mo.player.thrustfactor = 10
	local cmd = mo.player.cmd
	if P_PlayerInPain(mo.player) or mo.player.powers[pw_nocontrol] or mo.player.pflags&PF_SPINNING then return end
	//Movement
	if B.PlayerButtonPressed(mo.player,BT_JUMP,false)
		S_StartSound(mo,sfx_s3ka0)
	end
	if B.PlayerButtonPressed(mo.player,BT_JUMP) or (P_MobjFlip(mo) == 1 and mo.z < mo.floorz+16*mo.scale) or (P_MobjFlip(mo) == -1 and mo.z+mo.height > mo.ceilingz-16*mo.scale) then
		local w = 1
		if mo.eflags&MFE_UNDERWATER then w = 2 end
		local amt = mo.scale/w*5
		mo.momz = max(min($+amt/4*P_MobjFlip(mo),max(amt,$)),min(-amt,$))
	end
	mo.player.actiontime = $+1
	//Start Attack
	if B.PlayerButtonPressed(mo.player,BT_USE,false) and not(mo.player.actioncooldown) and mo.player.actionstate == 0 then
		mo.player.actionstate = 1
		mo.player.actiontime = 0
		local e = P_SpawnMobj(mo.x,mo.y,mo.z,MT_EGGROBOTAGCHARGE)
		e.target = mo
		e.scale = mo.scale/4
		B.ERCThink(e)
	end
	//Attack Charging
	if mo.player.actionstate == 1 then
		if mo.player.actiontime >= 15 then
			mo.player.actiontime = 0
			mo.player.actionstate = 2
			S_StartSound(mo,sfx_s3k5e)
			mo.player.storeangle = mo.angle
		end
	end
	//Attack Firing
	if mo.player.actionstate == 2 then
		mo.player.pflags = $|PF_STASIS 
		mo.player.drawangle = mo.player.storeangle
		mo.momz = 0
		if not(mo.player.actiontime&1) then
			local e = P_SPMAngle(mo,MT_EGGROBOTAGSHOT,mo.player.storeangle,mo.player.autoaim^^1) 
			P_InstaThrust(mo,mo.player.storeangle+ANGLE_180,mo.scale*3)
			if e and e.valid then
-- 				e.scale = mo.scale*2
				B.ERLShift(e)
				if mo.player.autoaim then
					B.AutoAim(mo,mo.player.storeangle,60,-1,true,e,mo.scale*36,MF_MONITOR|MF_BOSS|MF_ENEMY)
				end
			end
		end
		if mo.player.actiontime >= 10 then
			mo.player.actionstate = 0
			mo.player.actioncooldown = 15
			mo.player.storeangle = nil
		end
	end
	//Bombin'!
	if mo.player.actionstate == 0 then
		B.Action.BombThrow(mo,doaction,throwring,tossflag)
	end
end

//-Egg Robo death giblets-
B.EggRoboGiblet = function(mo)
	if mo.fuse&1 then
		mo.flags2 = $|MF2_DONTDRAW
	else
		mo.flags2 = $&~MF2_DONTDRAW
	end
end