local B = CBW_Battle

B.PlayerCorkDamage = function(pmo,mo,source)
	if not(mo and mo.valid and mo.type == MT_CORK) then return end
	if pmo.player and source and source.valid and source.player and not(B.MyTeam(source.player,pmo.player))
		local vulnerable = B.PlayerCanBeDamaged(pmo.player)
-- 		B.DoSPriority(pmo.player,mo)
		if vulnerable and pmo.player.battle_def != 0 then
			B.ResetPlayerProperties(pmo.player,false,false)
			local thrust
			if P_IsObjectOnGround(pmo) then
				thrust = 12
				P_InstaThrust(pmo,mo.angle,mo.scale*thrust)		
				pmo.state = S_PLAY_SKID
			else
				pmo.momz = $/2
				P_SetObjectMomZ(pmo,FRACUNIT*10/B.WaterFactor(pmo),1)
				thrust = 5
				P_InstaThrust(pmo,mo.angle,mo.scale*thrust)
				pmo.state = S_PLAY_FALL
			end
			S_StartSound(pmo,sfx_s3k7b)
			//Do uncurling, skidding
			pmo.player.powers[pw_nocontrol] = max($,thrust*2)
			pmo.recoilthrust = FixedHypot(pmo.momx,pmo.momy)
			pmo.recoilangle = R_PointToAngle2(0,0,pmo.momx,pmo.momy)
			P_RemoveMobj(mo)
			return false
		elseif not(vulnerable) then
			P_Thrust(pmo,mo.angle,mo.scale*12)
			S_StartSound(mo,sfx_s3k7b)		
			return false
		else
			return true
		end
	end
end

B.Action.BombThrow=function(mo,doaction,throwring,tossflag)
	local player = mo.player

	if not(B.CanDoAction(mo.player)) then return end
	//Action info
	mo.player.actiontext = "Throw Bomb"
	mo.player.actionrings = 10
	mo.player.action2text = "Drop Bomb"
	mo.player.action2rings = 10
	doaction = B.CheckRings(mo.player,$)
	
	local bombfuse
	if player.actiontype != "tageggrobo" then
		bombfuse = 5
	else
		bombfuse = 15
	end



	//Throw bomb
	if not(mo.player.actioncooldown) and doaction>0 and (throwring|tossflag)&1 then
		local bomb = P_SPMAngle(mo,MT_FBOMB,mo.angle,mo.player.autoaim^^1)
		B.PayRings(mo.player,mo.player.actionrings)
		mo.player.actioncooldown = TICRATE/2
		if bomb and bomb.valid then
			if G_RingSlingerGametype() or B.BattleGametype() then
				//Do skincolor
				bomb.state = S_COLORBOMB1
				bomb.color = mo.player.skincolor
			end
			
			//Do Physics
			local water = B.WaterFactor(mo)
			if not(throwring&1) then
				P_InstaThrust(bomb,mo.angle,FRACUNIT/100)
				bomb.momz = bomb.scale*4*P_MobjFlip(mo)/water
			elseif mo.player.autoaim and B.AutoAim(mo,mo.angle,45,-1,true,bomb,bomb.scale*20/water,MF_MONITOR|MF_BOSS|MF_ENEMY)
				then
				bomb.momz = $+bomb.scale*2*P_MobjFlip(mo)/water
			elseif mo.player.autoaim
				bomb.momz = $+bomb.scale*8*P_MobjFlip(mo)/water
			else
				bomb.momz = $+bomb.scale*4*P_MobjFlip(mo)/water
			end
			bomb.flags = $|MF_BOUNCE|MF_GRENADEBOUNCE
			bomb.fuse = bombfuse*TICRATE
			bomb.staticfuse = true
		end
	end
end

B.FBombThink=function(mo)
	if mo.flags&(MF_MISSILE|MF_GRENADEBOUNCE) and P_IsObjectOnGround(mo) then
		P_SetObjectMomZ(mo,FRACUNIT*4)
	end
	//Set collision properties
	local vthreshold = mo.scale*12
	local hthreshold = mo.scale*8
	if abs(mo.momz) > vthreshold then
		mo.flags = $&~MF_GRENADEBOUNCE
	else
		mo.flags = $|MF_GRENADEBOUNCE
	end
	if FixedHypot(mo.momx,mo.momz) > hthreshold then
		mo.flags = $&~MF_BOUNCE
	else
		mo.flags = $|MF_BOUNCE
	end
end

B.FBombDetonate=function(mo)
	mo.momx = 0
	mo.momy = 0
	mo.momz = 0
	S_StartSound(mo,sfx_s3k4e)
	P_KillMobj(mo)
	return true
end

B.PlayerBombDamage = function(pmo,mo,source)
	if mo and mo.valid and mo.type == MT_FBOMB and mo.fuse and pmo and pmo.valid and pmo.player and source and source.valid and source.player
		and B.PlayerCanBeDamaged(pmo.player) and not(B.MyTeam(pmo.player,source.player))
		then mo.fuse = 1
	end
end
B.BombCollide = function(bomb,mo)
	if mo and mo.valid and mo.flags&(MF_MISSILE|MF_ENEMY|MF_BOSS|MF_MONITOR) and bomb and bomb.valid and bomb.fuse > 1 
		and B.ZCollide(bomb,mo)
		then
		bomb.fuse = 1
		if mo.flags&MF_MONITOR then P_KillMobj(mo,bomb,bomb.target) end
	end
end