local B = CBW_Battle

B.DoDebris=function(mo,large,speed)
	local scale
	if large then scale = mo.scale/2
	else scale = mo.scale/3
	end
	local debris = P_SpawnMobj(mo.x,mo.y,mo.z,MT_ROCKCRUMBLE2)
	if debris and debris.valid then
		debris.scale = scale
		debris.flags2 = $|(mo.flags2&MF2_OBJECTFLIP)
		debris.z = $+FRACUNIT
		if P_IsObjectOnGround(mo) then
			P_InstaThrust(debris,P_RandomRange(0,259)*ANG1,speed*scale)
			debris.momz = speed*scale*P_MobjFlip(mo)
		else
			B.InstaThrustZAim(debris,mo.angle+ANGLE_180+P_RandomRange(-89,89)*ANG1,P_RandomRange(-89,89)*ANG1,speed*scale)
		end
	end
	return debris
end

B.Action.Dig=function(mo,doaction,throwring,tossflag)
	if mo.player.playerstate != PST_LIVE then 
		mo.flags2 = $&~MF2_DONTDRAW
		return
	end
	if not(B.CanDoAction(mo.player)) then
		doaction = 0
		throwring = 0
		tossflag = 0
	end
	
	local dojump = B.PlayerButtonPressed(mo.player,BT_JUMP,false)
	local dospin = B.PlayerButtonPressed(mo.player,BT_USE,false)
	
	local sludge = mo.eflags&MFE_GOOWATER or P_InQuicksand(mo)
	local grounded = P_IsObjectOnGround(mo)
	
	local resurfacetime = TICRATE*22/10
	local setburrowtime = 22 + resurfacetime
	
	local diggingstates = (mo.player.actionstate == 3 or mo.player.actionstate == 1)
	
	mo.player.actiontextflags = 0
	mo.player.action2textflags = 0
	//Normal state; ready to dig
	if mo.player.actionstate == 0 then
		mo.player.actiontext = "Dig"
		mo.player.actionrings = 8
		mo.player.action2text = nil
		mo.player.action2rings = nil
	//2 = downward air drill; disallow actions.
	elseif not(diggingstates)
		mo.player.actiontext = nil
		mo.player.action2text = nil
	//1 = digging, disallow actions. 3 = Burrowed; ready to resurface.
	else
		if mo.player.actionstate == 1 then
			mo.player.actiontextflags = 1
			mo.player.action2textflags = 1
		end
		mo.player.actiontext = "Rock Blast"
		mo.player.actionrings = 8
		if mo.player.actionrings > mo.player.rings then
			mo.player.actiontextflags = 3
		end
		mo.player.action2text = "Resurface "..G_TicsToSeconds(mo.player.actiontime).."."..G_TicsToCentiseconds(mo.player.actiontime)
	end

	doaction = 0
	if (throwring==1) or (diggingstates and dojump) then
		if not(mo.player.actioncooldown) and mo.player.rings >= mo.player.actionrings then
			doaction = 1
		else
			mo.player.spendrings = -1
			doaction = 0
		end
	end
	if P_PlayerInPain(mo.player) and mo.player.actionstate then
		B.ResetPlayerProperties(mo.player,false,false)
		return
	end
	
	//Execute dig
	if (doaction == 1 and throwring == 1 and not(sludge) and mo.player.actionstate == 0 and (grounded or mo.player.climbing))
		or (grounded and mo.player.actionstate == 2 and not(sludge))
		then
		if mo.player.actionstate == 0 then
			B.PayRings(mo.player)
		end
		mo.player.actionstate = 1
		mo.player.actiontime = setburrowtime
		mo.flags = $|MF_NOCLIPTHING
		mo.flags2 = $|MF2_DONTDRAW
		mo.player.pflags = $|PF_JUMPSTASIS
		mo.player.normalspeed = skins[mo.skin].normalspeed*3/8
		S_StartSound(mo,sfx_s3kccs)
		return
	//Execute downward air drill
	elseif not(grounded) and not(sludge) and doaction == 1 and throwring == 1 and mo.player.actionstate == 0 then
		B.PayRings(mo.player)
		mo.player.actionstate = 2
		mo.player.actiontime = 0
		mo.state = S_PLAY_ROLL
		local dir = R_PointToAngle2(0,0,mo.momx,mo.momy)
		local speed = FixedHypot(mo.momx,mo.momy)
		B.InstaThrustZAim(mo,dir,-ANGLE_90,min(speed,mo.scale*36))
		mo.momz = min(-12*mo.scale,mo.momz*P_MobjFlip(mo))*P_MobjFlip(mo)
		mo.player.pflags = $|(PF_JUMPED|PF_THOKKED)&~(PF_GLIDING)
		S_StartSound(mo,sfx_zoom)
		return
	end
	if mo.player.actionstate == 2 then
		P_SpawnThokMobj(mo.player)
	end
	
	if mo.player.actionstate == 2 and mo.momz*P_MobjFlip(mo) > 0 then
		B.ResetPlayerProperties(mo.player,true,false)
	end

	if not(diggingstates)
		then return 
	//Eject player
	elseif mo.player.actiontime <= 0 or (grounded and sludge) or (mo.player.actionstate == 3 and (tossflag == 1 or dospin)) or not(grounded or mo.player.climbing) then
		P_SetObjectMomZ(mo,FRACUNIT*4,false)
		B.ResetPlayerProperties(mo.player,false,false)
-- 		P_DoJump(mo.player,true)
		mo.state = S_PLAY_FALL
		S_StartSound(mo,sfx_s3k82)
		for n = 0, 10
			B.DoDebris(mo,P_RandomChance(FRACUNIT/2),P_RandomRange(5,10))
		end
		mo.player.actioncooldown = TICRATE
		mo.player.powers[pw_nocontrol] = 2
		return
	end
	mo.flags = $|MF_NOCLIPTHING
	mo.flags2 = $|MF2_DONTDRAW
	mo.player.charability2 = 0
	
	mo.player.actiontime = $-1
	
	//Burrowing
	if mo.player.actionstate == 1
		mo.player.pflags = $|PF_JUMPSTASIS|PF_STASIS
		if mo.player.actiontime <= resurfacetime
			mo.player.actionstate = 3
		end
		B.DoDebris(mo,P_RandomChance(FRACUNIT/2),P_RandomRange(5,20))
		return
	end
	mo.player.pflags = ($|PF_JUMPSTASIS)&~PF_STASIS

	//Moving while burrowed
	if abs(mo.player.cmd.forwardmove) or abs(mo.player.cmd.sidemove) then
		if not(mo.player.actiontime&3) then
			//Do Debris
			B.DoDebris(mo,P_RandomChance(FRACUNIT/2),P_RandomRange(3,5))
			S_StartSound(mo,sfx_s3k67)
		end
	end
	
	
	//Rock blast attack
	if (doaction)
		then
		mo.player.actionstate = 0
		B.PayRings(mo.player)
		mo.player.actioncooldown = TICRATE*5/2
		mo.player.pflags = $&~PF_JUMPSTASIS
		P_DoJump(mo.player,false)
		B.ResetPlayerProperties(mo.player,true,false)
		if mo.player.cmd.buttons&BT_JUMP then
			mo.player.pflags = $|PF_STARTJUMP|PF_JUMPDOWN
			A_ZThrust(mo, 7, 0)
		end
		S_StartSound(mo,sfx_s3k59)
		for n = 0, 7
			B.DoDebris(mo,P_RandomChance(FRACUNIT/2),P_RandomRange(3,20))
		end
		local time = 47
		if grounded then
			//Do horizontal debris burst
			//Anti-air Layer
			for n = 0,4
				local rock = P_SPMAngle(mo,MT_ROCKBLAST,0,0)
				if rock and rock.valid then
					B.InstaThrustZAim(rock,(ANG60+ANG30)*n,7*ANG10*P_MobjFlip(rock),rock.scale*14)
					rock.fuse = time
				end
			end
			//Second Layer
			for n = 0,6
				local rock = P_SPMAngle(mo,MT_ROCKBLAST,0,0)
				if rock and rock.valid then
					B.InstaThrustZAim(rock,ANG60*n,5*ANG10*P_MobjFlip(rock),rock.scale*14)
					rock.fuse = time
				end
			end
			//Third Layer
			for n = 0,12
				local rock = P_SPMAngle(mo,MT_ROCKBLAST,0,0)
				if rock and rock.valid then
					B.InstaThrustZAim(rock,ANG30*n,3*ANG10*P_MobjFlip(rock),rock.scale*14)
					rock.fuse = time
				end
			end
		else
			//Do vertical debris burst
			for n = 0,7
				local rock = P_SPMAngle(mo,MT_ROCKBLAST,0,0)
				if rock and rock.valid then
					B.InstaThrustSpread(rock,mo.angle,30,45*n,FRACUNIT*20)
					rock.fuse = time
				end
			end
			//Second Layer
			for n = 0,15
				local rock = P_SPMAngle(mo,MT_ROCKBLAST,0,0)
				if rock and rock.valid then
					B.InstaThrustSpread(rock,mo.angle,60,225*n/10,FRACUNIT*15)
					rock.fuse = time
				end
			end
		end
	end
end

