local B = CBW_Battle

B.Action.ChargeBlast=function(mo,doaction,throwring,tossflag)
	if doaction == -1 then
		mo.player.actionstate = 0
		mo.player.actiontime = -1
		return 
	end
	if not(mo.player.actionstate or mo.player.dashmode >= TICRATE*3) then
		mo.color = mo.player.skincolor
	end
	
	//Charge time thresholds
	local threshold1 = TICRATE
	local threshold2 = TICRATE*2
	
	//Action info
	mo.player.actiontext = "Energy Blast"
	mo.player.actionrings = 8
	mo.player.action2text = nil
	mo.player.action2rings = 0
	if mo.player.actionstate == 1 then
		if mo.player.actiontime < threshold2 then
			mo.player.action2text = 100*mo.player.actiontime/threshold2.."%"
		else
			mo.player.action2rings = 12
			mo.player.action2text = "Dash!"
			if leveltime&4 then
				mo.player.action2textflags = 3
			end
		end
	end
	if mo.player.actionstate != 1 then
		doaction = B.CheckRings(mo.player,doaction&throwring,mo.player.actionrings)
	else
		doaction = B.CheckRings(mo.player,doaction&throwring,1)
	end
	
	//Intercepted while charging
	if mo.player.metalcharging and mo.player.powers[pw_nocontrol] then
		mo.player.metalcharging = false 
		mo.player.actionstate = 0
		mo.player.actioncooldown = TICRATE
		return
	elseif not(mo.player.metalcharging) and mo.player.actionstate == 1 then
		mo.player.metalcharging = true
	elseif mo.player.metalcharging and mo.player.actionstate != 1 then
		mo.player.metalcharging = false
	end
	
	//Start charging blast
	if doaction == 1 then
		mo.player.actionstate = 1
		mo.player.actiontime = 0
		if mo.player.dashmode >= TICRATE*3 then
			mo.player.actiontime = threshold1
		end
		S_StartSound(mo,sfx_s3k7a)
		local a = P_SpawnMobj(mo.x,mo.y,mo.z,MT_ENERGYAURA)
		if a and a.valid then 
			a.target = mo
		end
	end
	mo.player.actiontime = $+1
	
	//Charging Blast
	if doaction == 2 and mo.player.actionstate == 1 then
		mo.player.dashmode = 0
		mo.player.pflags = $|PF_STASIS
		
		//Gather spheres
		local gather = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_ENERGYGATHER)
		if gather and gather.valid then
			gather.target = mo
			gather.fuse = 35
			gather.extravalue1 = P_RandomRange(0,359)*ANG1
			gather.extravalue2 = P_RandomRange(0,359)*ANG1
			gather.scale = mo.scale/4
		end
		
		//Speed Cap
		local speed = FixedHypot(mo.momx,mo.momy)
		if speed > mo.scale then
			local dir = R_PointToAngle2(0,0,mo.momx,mo.momy)
			P_InstaThrust(mo,dir,speed-mo.scale)
		end
		//Ring Drain
		if not(mo.player.actiontime&15) then
			mo.player.rings = max(0,$-1)
			S_StartSound(mo,sfx_itemup,mo.player)
		end
		//Blast Powerup
		if mo.player.actiontime >= threshold1 then
			if not(mo.player.actiontime&3)
				then
				S_StartSound(mo,sfx_s3k5c)
				P_SpawnThokMobj(mo.player)
			end
			if mo.player.actiontime == threshold2 then
			S_StartSound(nil,sfx_s1c3,player)
				for l = 0,8
					P_SpawnParaloop(mo.x,mo.y,mo.z+mo.height/2,256*mo.scale,16,MT_NIGHTSPARKLE,mo.angle+45*l*ANG1,nil,1)
				end
			end
			if mo.player.actiontime >= threshold2 then
				local thok = P_SpawnMobj(mo.x+P_RandomRange(-mo.radius/FRACUNIT,mo.radius/FRACUNIT)*FRACUNIT,mo.y+P_RandomRange(-mo.radius/FRACUNIT,mo.radius/FRACUNIT)*FRACUNIT,mo.z,MT_THOK)
				if thok and thok.valid then
					thok.scale = $/16
					P_SetObjectMomZ(thok,FRACUNIT*16*8)
					thok.momx = mo.momx
					thok.momy = mo.momy
					thok.color = SKINCOLOR_WHITE
				end
			end
		end
	end
	
	//Dash burst
	if mo.player.actionstate == 1 and (mo.player.actiontime >= threshold2 and tossflag == 1) then
		B.ResetPlayerProperties(mo.player,true,true)
		mo.player.pflags = $|PF_NOJUMPDAMAGE&~PF_JUMPDOWN
		mo.player.actiontime = -1
		S_StartSound(mo,sfx_s3k54)
		B.PayRings(mo.player,mo.player.action2rings)
		P_InstaThrust(mo,mo.angle,mo.player.normalspeed)
		mo.state = S_PLAY_DASH
		mo.player.actioncooldown = 12
		mo.player.dashmode = TICRATE*3
	end
		
	//Unable to charge
	if mo.player.actionstate == 1 and (not(mo.player.rings) or B.PlayerButtonPressed(mo.player,BT_USE,false)) then
		B.ResetPlayerProperties(mo.player,false,false)
		mo.player.actiontime = -1
		S_StartSound(mo,sfx_s3k7d)
		mo.player.actioncooldown = 6
	end
	//Release blast
	if doaction == 0 and mo.player.actionstate == 1 then
		mo.player.actionstate = 2
		S_StartSound(mo,sfx_s3k54)
		local blast = P_SPMAngle(mo,MT_ENERGYBLAST,mo.angle,mo.player.autoaim^^1)
		if blast and blast.valid then
			blast.scale = (mo.scale/400)*(200+mo.player.actiontime)
			local speed = blast.info.speed
			if mo.player.autoaim then
				B.AutoAim(mo,mo.angle,45,-1,true,blast,speed,MF_MONITOR|MF_BOSS|MF_ENEMY)
			end
			local xyangle = R_PointToAngle2(0,0,blast.momx,blast.momy)
			local zangle = B.GetZAngle(0,0,0,blast.momx,blast.momy,blast.momz)
			//Spread shot
			if mo.player.actiontime > threshold1 then
				local m = 3
				if mo.player.actiontime > threshold2 then
					m = 7
				end
				for n = 0, m
					local scatter = P_SPMAngle(mo,MT_ENERGYBLAST,mo.angle,0)
					if scatter and scatter.valid then
						scatter.scale = blast.scale
						local bias = ANG1*3
						if n&4 then bias = $*2 end
						local xyanglebias = 0
						local zanglebias = 0
						if n&~4 == 0 then
							xyanglebias = -bias
						elseif n&~4 == 1 then
							xyanglebias = bias
						elseif n&~4 == 2 then
							zanglebias = -bias
						elseif n&~4 == 3 then
							zanglebias = bias
						end
						B.InstaThrustZAim(scatter,xyangle+xyanglebias,zangle+zanglebias,speed)
					end
				end
			end

		end
		P_InstaThrust(mo,mo.angle+ANGLE_180,6*mo.scale)
		mo.player.actiontime = 0
		B.PayRings(mo.player)
		mo.player.actioncooldown = 12
	end
	//Update states
	if mo.player.actionstate == 1 then
		mo.state = S_PLAY_ROLL
		mo.player.drawangle = mo.angle
		mo.player.pflags = ($|PF_JUMPED)&~PF_NOJUMPDAMAGE
		mo.momz = P_MobjFlip(mo)*mo.scale/4 //Rise slowly
		if mo.player.actiontime&6 >= 6 then
			mo.color = SKINCOLOR_RED
		elseif mo.player.actiontime&4 then
			mo.color = SKINCOLOR_RUST
		else
			mo.color = mo.player.skincolor
		end
	elseif (mo.player.actiontime == -1) then
		mo.color = mo.player.skincolor
		mo.player.actiontime = 0
	end
	//Charge release state
	if mo.player.actionstate == 2 then
		mo.state = S_PLAY_SPRING
		mo.player.pflags = $|(PF_JUMPED|PF_NOJUMPDAMAGE|PF_THOKKED)&~PF_JUMPDOWN
		mo.player.secondjump = 0
		mo.momz = 0
		mo.color = mo.player.skincolor
		if mo.player.actiontime > 15 then
			mo.player.actiontime = 0
			mo.player.actionstate = 0
		end
	end
end

//-Metal Energy Aura-
B.MetalAura = function(mo,target)
	if not(target and target.valid and target.player and target.player.actionstate == 1)
		then 
		P_RemoveMobj(mo)
	return end
	mo.scale = target.scale
	P_TeleportMove(mo,target.x,target.y,target.z-target.height/4)
end

//-Metal Sonic "gather" spheres-
B.EnergyGather = function(mo,target,xyangle,zangle)
	if not(target and target.valid and target.player and target.player.actionstate == 1) then
		P_RemoveMobj(mo)
	return end
	local dist = FRACUNIT*16*mo.fuse
	local xydist = P_ReturnThrustX(nil,zangle,dist)
	local zdist = P_ReturnThrustY(nil,zangle,dist)
	local x = target.x+P_ReturnThrustX(nil,xyangle,xydist)
	local y = target.y+P_ReturnThrustY(nil,xyangle,xydist)
	local z = target.z+zdist+target.height/2
	P_TeleportMove(mo,x,y,z)
end