CBW_Battle.Action.SuperSpinJump=function(mo,doaction)	
	//Action info
	if P_IsObjectOnGround(mo) then
		mo.player.actiontext = "Super Spin Jump"
		mo.player.actionrings = 10
	else
		mo.player.actiontext = "Ground Pound"
		mo.player.actionrings = 10
	end
	mo.player.action2text = nil
	
	doaction = CBW_Battle.CheckRings(mo.player,$)
	
	local water = CBW_Battle.WaterFactor(mo)
	local thrust
	local jumpflags = (mo.player.pflags|PF_JUMPED|PF_THOKKED)&~(PF_STARTJUMP|PF_NOJUMPDAMAGE|PF_GLIDING|PF_BOUNCING|PF_SPINNING)
	if mo.player.actionstate == 0
		if doaction == 1 then
			CBW_Battle.PayRings(mo.player)
			//Do high jump
			if P_IsObjectOnGround(mo) then
				mo.player.actionstate = 2 
-- 				P_DoJump(mo.player,true)
				thrust = 18*FRACUNIT/water
				P_SetObjectMomZ(mo,thrust,true) //Inherit platform momentum
-- 				P_InstaThrust(mo,mo.angle,0)
				S_StartSound(mo,sfx_s3k3c)
				S_StartSound(mo,sfx_kc5b)
				mo.player.pflags = jumpflags
				mo.state = S_PLAY_ROLL
				mo.player.secondjump = 0
			else//Do ground pound
				thrust = 24*FRACUNIT/water
				mo.player.actionstate = 1 
				P_SetObjectMomZ(mo,-thrust,false) //Thrust downwards
				S_StartSound(mo,sfx_zoom)
				mo.state = S_PLAY_ROLL
				mo.player.pflags = jumpflags
				mo.player.secondjump = 0
			end
		end
	elseif mo.player.actionstate == 1 //Pound state
		mo.player.actioncooldown = TICRATE/2
		if mo.momz*P_MobjFlip(mo) > 0 then //If we're moving upward, then something must have interrupted us.
			mo.player.actionstate = 0
			mo.state = S_PLAY_SPRING
			mo.player.pflags = $&~(PF_JUMPED)
		else
			if P_IsObjectOnGround(mo) then
				thrust = 10*FRACUNIT/water
				P_SetObjectMomZ(mo,thrust,true) //Inherit platform momentum
				S_StartSound(mo,sfx_s3k5f)
				mo.player.state = S_PLAY_SPRING
				P_InstaThrust(mo,R_PointToAngle2(0,0,mo.momx,mo.momy),FixedHypot(mo.momx,mo.momy)/4)
				//Create projectile blast
				for n = 0, 23
					local p = P_SPMAngle(mo,MT_GROUNDPOUND,mo.angle+n*ANG15,0)
					if p and p.valid then
						p.momz = mo.scale*P_MobjFlip(mo)*2/water
						p.fuse = TICRATE/3
					end
				end
			end
		end
	elseif mo.player.actionstate == 2 //SuperSpinJump state
		if mo.momz*P_MobjFlip(mo) < 0 then //Go into fall frames after rising
			mo.state = S_PLAY_FALL
			mo.player.pflags = $&~(PF_JUMPED)
			mo.player.actionstate = 0
		end
		if P_IsObjectOnGround(mo) then
			mo.player.actionstate = 0
		end
	end
	if mo.player.actionstate and mo.player.pflags&PF_JUMPED then
		P_SpawnThokMobj(mo.player)
	end
end