local B = CBW_Battle
local PFunc = B.PriorityFunction

B.AddPriorityFunction = function(name,func)
	if not(name) then //Invalid name
		print("\x82 WARNING: Invalid argument #1 provided for CBW_Battle.AddPriorityFunction()")
	return nil end
	if not(type(name) == "string") then //Name isn't a string
		print("\x82 WARNING: Argument #1 for CBW_Battle.AddPriorityFunction() must be a string!")
	return nil end
	if PFunc[name] != nil then //Name already exists
		print("\x82 WARNING: CBW_Battle.PriorityFunction['"..name.."'] is already defined!")
	return nil end
	if not(func) then //Invalid function argument
		print("\x82 WARNING: Invalid argument #2 provided for CBW_Battle.AddPriorityFunction()")
	return nil end
	if not(type(func) == "function") then //argument type is not a function
		print("\x82 WARNING: Argument #2 for CBW_Battle.AddPriorityFunction() must be a function!")
	return nil end
	PFunc[name] = func
	return name
end

local Add = B.AddPriorityFunction

Add("basic",B.Priority_Core)
Add("abilities",B.Priority_Ability)
Add("tails_fly",B.SPriority_Fly)
Add("knuckles_glide",B.SPriority_Glide)
Add("amy_twinspin",B.SPriority_TwinSpin)
Add("amy_melee",B.SPriority_Melee)
Add("fang_tailbounce",B.SPriority_TailBounce)
Add("stomp_damage",B.SPriority_StompDamage)

B.AddCharPriority = function(skin,func,extfunc)
	if not(skin and type(skin) == "string") then print("\x82 WARNING: Argument #1 for CBW_Battle.AddCharPriority() must be a string!") return nil end
	if (func and type(func) != "string") then print("\x82 WARNING: Argument #2 for CBW_Battle.AddCharPriority() is not a string! Using 'nil' instead") end
	if (extfunc and type(extfunc) != "string") then print("\x82 WARNING: Argument #3 for CBW_Battle.AddCharPriority() is not a string! Using 'nil' instead") end
	if func and not(PFunc[func]) then print("\x82 WARNING: Argument #2 '"..func.."' for CBW_Battle.AddCharPriority() does not refer to a registered priority function. Please run CBW_Battle.AddPriorityFunction() first.") end
	if extfunc and not(PFunc[extfunc]) then print("\x82 WARNING: Argument #3 '"..extfunc.."' for CBW_Battle.AddCharPriority() does not refer to a registered priority function. Please run CBW_Battle.AddPriorityFunction() first.") end
	B.CharPrioritySet[skin] = true
	B.CharPriorityFunc[skin] = func
	B.CharPriorityExtFunc[skin] = extfunc
end

local Add = B.AddCharPriority

Add("sonic","basic","abilities")
Add("tails","basic","abilities")
Add("knuckles","basic","abilities")
Add("amy","basic","abilities")
Add("fang","basic","abilities")
Add("metalsonic","basic","abilities")

B.PriorityCheckSkinSet = function()
	for skin in skins.iterate()
		local s = skin.name
		if not(B.CharPrioritySet[s]) then
			print("Character Priority functions not set for skin "..s..". Setting to default.")
			Add(s,"basic","abilities")
		end
	end
end

B.SetPlayerPriorityFunc = function(player)
	if not(player.mo and player.mo.valid and player.mo.skin) then return end
	local skin = player.mo.skin
	local func = B.CharPriorityFunc[skin]
	local extfunc = B.CharPriorityExtFunc[skin]
	player.battle_func = func
	player.battle_extfunc = extfunc
	player.battle_sfunc = nil
end