local B = CBW_Battle
//-Player ThinkFrame-

B.PlayerThinkFrame = function(player)
	local pmo = player.mo
	//Validity check
	if not(pmo and pmo.valid) or player.playerstate != PST_LIVE then return end
	//Game Mode Check
	if maptol&(TOL_NIGHTS|TOL_XMAS) then return end
	
	//Ability control
	B.GunControl(player)
	B.ShieldAbility(player)
	
	//Update timers/stats
	B.GotFlagStats(player)
	player.charmedtime = max(0,$-1)
	player.actioncooldown = max(0,$-1)
	B.DoCharmed(player)
	B.DoBackdraft(player)
	
	//PvP Collision
	B.DoPlayerInteract(pmo,pmo.pushed)
	B.UpdateRecoilState(pmo)
	B.UpdateCollisionHistory(pmo)

	//Perform Actions
	player.actionallowed = B.CanDoAction(player)
	player.actioncooldown = max($,player.tossdelay-TICRATE)
	local doaction = 0
	local tossflag = 0
	local throwring = 0
	
	local function buttoncheck(button)
		if player.cmd.buttons&button then
			if player.buttonhistory&button then
				return 2
			else
				return 1
			end
		end
		return 0
	end
	
	throwring = max(0,buttoncheck(BT_ATTACK))
	tossflag = max(max(0,buttoncheck(BT_TOSSFLAG)),buttoncheck(BT_FIRENORMAL))
	
	doaction = (tossflag|throwring)
	B.MasterActionScript(player,doaction,throwring,tossflag)
end