local TF_GRAY = 1
local TF_YELLOW = 2
local TF_RED = 3
local B = CBW_Battle
local CV = B.Console
local CP = B.ControlPoint


//-Special Moves-
local function actionhud(v, player, cam)
	if player.playerstate != PST_LIVE then return end
	if not(CV.Actions.value) then return end
	if player.actionallowed != true and not player.gotflag then return end
	if G_TagGametype() and leveltime < 30*TICRATE then return end
	local blink = false
	local xoffset = 16
	local flags = V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER
	local align = "thin"
	//Action 1 text
	local yoffset = 56
	local text = player.actiontext
	local textflags = player.actiontextflags
	if player.gotflag then
		text = "Got flag!"
		if leveltime&4 then
			text = "\x82"+$
		end
		local patch = v.cachePatch("TOSSFLAG")
		v.draw(xoffset,yoffset,patch,flags)
		v.drawString(xoffset+12,yoffset,text,flags,align)
	end
	if not(player.gotflag) and text and not(player.actioncooldown and leveltime&1) then 
		if player.actioncooldown then
			textflags = TF_GRAY
			text = "Cooldown "..G_TicsToSeconds(player.actioncooldown).."."..G_TicsToCentiseconds(player.actioncooldown)
		elseif textflags == nil then
			textflags = 0
			if (player.actionstate == 0 and player.actionrings > player.rings) then
				textflags = $|TF_GRAY
			end		
			if player.actionstate then
				textflags = $|TF_YELLOW
			end
		end
		if textflags == TF_GRAY then
			text = "\x86"+$
		elseif textflags == TF_YELLOW then
			text = "\x82"+$
		elseif textflags == TF_RED then
			text = "\x85"+$
		else
			text = "\x80"+$
		end
		if player.actionrings and not(player.actioncooldown) then 
			text = "\x82"+player.actionrings+"\x80 "+$
		end
		//Draw
		local patch = v.cachePatch("THRWRING")
		v.draw(xoffset,yoffset,patch,flags)
		v.drawString(xoffset+12,yoffset,text,flags,align)
	end
	//Action 2 text
	yoffset = $+10
	text = player.action2text
	textflags = player.action2textflags
	if not(player.gotflag) and text and not(player.actioncooldown) then 
		if textflags == nil then
			textflags = 0
			if (player.actionstate == 0 and player.action2rings > player.rings) then
				textflags = $|TF_GRAY
			end		
			if player.actionstate then
				textflags = $|TF_YELLOW
			end
		end
		if textflags == TF_GRAY then
			text = "\x86"+$
		elseif textflags == TF_YELLOW then
			text = "\x82"+$
		elseif textflags == TF_RED then
			text = "\x85"+$
		else
			text = "\x80"+$
		end
		if player.action2rings then 
			text = "\x82"+player.action2rings+"\x80 "+$
		end
		//Draw
		local patch = v.cachePatch("TOSSFLAG")
		v.draw(xoffset,yoffset,patch,flags)
		v.drawString(xoffset+12,yoffset,text,flags,align)
	end
end

//Control Point
local function cphud(v, player, cam)
	if not(player.truemo and CP.Mode and server) then return end
	local flags = V_HUDTRANS|V_SNAPTOTOP|V_PERPLAYER
	local xoffset = 152
	local yoffset = 4
	local time = CP.Timer
	local angle
	local compass
	local color
	local pid = CP.ID[CP.Num]
	if (CP.Active or (time <= 10*TICRATE and time&1)) and player.truemo and player.truemo.valid and pid and pid.valid then
		angle = R_PointToAngle2(player.truemo.x,player.truemo.y,pid.x,pid.y) - player.cmd.angleturn<<16 //R_PointToAngle(player.truemo.x,player.truemo.y)
		compass = v.getSpritePatch("CMPS",A,min(8,max(1,-(angle)/ANG1/40+5))) //Angle math is weird, idk
		local pcol = pid.color
		if (G_GametypeHasTeams() and not(CP.Capturing or CP.Blocked)) or pid.color == SKINCOLOR_JET then
			pcol = SKINCOLOR_SILVER
		end
		color = v.getColormap(TC_DEFAULT,pcol)
		//Draw
		v.draw(xoffset,yoffset,compass,flags,color)
	end
	local text = ""
	local center = 8
	local left = -2
	local right = 20
	local blue = center-1
	local red = center+1
	local bottom = 12
	local centeralign = "center"
	local leftalign = "thin-right"
	local rightalign = "thin"
	if time then
		text = time/TICRATE
		v.drawString(xoffset+center,yoffset+bottom,text,flags,centeralign)
	elseif CP.Active then
		if not(G_GametypeHasTeams()) then
			if CP.LeadCapPlr and CP.LeadCapPlr.valid and CP.LeadCapPlr.mo and CP.LeadCapPlr.mo.valid
			and CP.LeadCapPlr.captureamount == CP.LeadCapAmt and CP.LeadCapPlr.playerstate == PST_LIVE
				v.draw(xoffset+right+(center*2), yoffset+bottom, v.getSprite2Patch(CP.LeadCapPlr.mo.skin, SPR2_LIFE),
				flags|V_FLIP, v.getColormap(nil, CP.LeadCapPlr.mo.color))
			end
			text = "\x82"..CP.LeadCapAmt*100/CP.Meter.."%"
			v.drawString(xoffset+right,yoffset+4,text,flags,rightalign)
			if player.mo and CP.Active
				v.draw(xoffset+left-(center*2), yoffset+bottom, v.getSprite2Patch(player.mo.skin, SPR2_LIFE),
				flags, v.getColormap(nil, player.mo.color))
				text = player.captureamount*100/CP.Meter.."%"
				v.drawString(xoffset+left,yoffset+4,text,flags,leftalign)
			end
		else
			text = CP.TeamCapAmt[2]*100/CP.Meter.."%"
			v.drawString(xoffset+blue,yoffset+4+bottom,text,flags,leftalign)
			text = CP.TeamCapAmt[1]*100/CP.Meter.."%"
			v.drawString(xoffset+red,yoffset+4+bottom,text,flags,rightalign)
		end		
	end
end

//DrawDebug
local function debughud(v, player, cam)
	local xoffset = 320
	local yoffset = 1
	local flags = V_HUDTRANS|V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER
	local align = "thin-right"
	local func = player.battle_func
	if func == nil then func = "nil" end
	local extfunc = player.battle_extfunc
	if extfunc == nil then extfunc = "nil" end
	local sfunc = player.battle_sfunc
	if sfunc == nil then sfunc = "nil" end
	if CV.Debug.value then
		v.drawString(xoffset,yoffset,"actiontype: "+player.actiontype,flags,align)
		yoffset = $+8
		v.drawString(xoffset,yoffset,"actionstate: "+player.actionstate,flags,align)
		yoffset = $+8
		v.drawString(xoffset,yoffset,"actiontime: "+player.actiontime,flags,align)
		yoffset = $+8
		v.drawString(xoffset,yoffset,"actionrings: "+player.actionrings,flags,align)
		yoffset = $+8
		v.drawString(xoffset,yoffset,"action2rings: "+player.action2rings,flags,align)
		yoffset = $+8
		v.drawString(xoffset,yoffset,"actioncooldown: "+player.actioncooldown,flags,align)
		yoffset = $+8
		v.drawString(xoffset,yoffset,"battle_func: "+func,flags,align)
		yoffset = $+8
		v.drawString(xoffset,yoffset,"battle_extfunc: "+extfunc,flags,align)
		yoffset = $+8
		v.drawString(xoffset,yoffset,"battle_sfunc: "+sfunc,flags,align)
		yoffset = $+8
		v.drawString(xoffset,yoffset,"battle_atk: "+player.battle_atk,flags,align)
		yoffset = $+8
		v.drawString(xoffset,yoffset,"battle_def: "+player.battle_def,flags,align)
		yoffset = $+8
		v.drawString(xoffset,yoffset,"battle_satk: "+player.battle_satk,flags,align)
		yoffset = $+8
		v.drawString(xoffset,yoffset,"battle_sdef: "+player.battle_sdef,flags,align)
		yoffset = $+8
	end
end

hud.add(actionhud, player)
hud.add(cphud, player)
hud.add(debughud, player)